#!/usr/bin/perl
## ######### PROJECT NAME : ##########
## 
## main.pl for wishmin
## 
## ######### PROJECT DESCRIPTION : ###
## 
## this script handle module execution
## 
## ###################################
## 
## Made by Boutonnet Alexandre
## Email   <aboutonnet@intellique.com>
## 
## Started on  Wed May 27 15:28:57 2009 Boutonnet Alexandre
## Last update Thu May 28 16:37:18 2009 Boutonnet Alexandre
## 
## ###################################
##

use IPC::Run3;
use Lib_Modules;
use HTML::Entities;

my $MOD_DIR = "modules/";

Lib_TT::new_tt("templates/global/", "templates/call/");
Lib_Translation::init("call.lang");

my $module = Lib_CGI::get_param('call');

# Gestion pour les post sans param hidden
$module = Lib_CGI::get_url_param('call') if (!$module);

my ($err_modules, $modules_hash) = Lib_Modules::list_modules();
Lib_CGI::send_critical_header($modules_hash) if ($err_modules);

if (!$module) { Lib_TT::set("error_msg", Translate("error_msg_no_module")); }
elsif (!exists($modules_hash->{$module})) { Lib_TT::set("error_msg", Translate("error_msg_module_not_exist")); }
elsif (Lib_Modules::is_executable($module, $modules_hash->{$module}->{'entry_point'}))
{ Lib_TT::set("error_msg", Translate("error_msg_module_not_exec")); }
else
{
    # I execute my module
    my $cmd = Lib_Modules::get_executable_cmd($module, $modules_hash->{$module}->{'entry_point'});

    my $stdout;
    my $errout;

# DEPRECATED -> I MAKE A BACKUP OF THE STDIN
#     # I create the post data to put on stdin
#     my $stdin = '';
#     my $flag_backslash_n = 0;
#     foreach my $param (Lib_CGI::get_all_params())
#     {
# 	my @tab_param = Lib_CGI::get_param($param);
# 	foreach my $value (@tab_param)
# 	{
# 	    if ($stdin eq "") { $stdin .= "$param=$value"; }
# 	    else { $stdin .= "&$param=$value"; }
# 	    $flag_backslash_n = 1;
# 	}
#     }
#     $stdin .= "\n" if ($flag_backslash_n);

    my $stdin = Lib_CGI::get_stdin_buffer();

    run3($cmd, $stdin, \$stdout, \$errout);
    
    # If my process exit with a value != 0
    Lib_TT::set("error_msg", encode_entities($errout)) 
	if ($?);

    Lib_TT::set("module_html_output", $stdout);

}

##### Just Do it !
Lib_TT::set("link_logout", Translate("link_logout"));
Lib_TT::set("page_title", $module);


Lib_CGI::print_html_header();
Lib_TT::process("call.tt");

1;
