#!/usr/bin/perl
## ######### PROJECT NAME : ##########
## 
## main.pl for wishmin
## 
## ######### PROJECT DESCRIPTION : ###
## 
## this file makes all the first page job
## 
## ###################################
## 
## Made by Boutonnet Alexandre
## Email   <aboutonnet@intellique.com>
## 
## Started on  Fri May 15 12:24:32 2009 Boutonnet Alexandre
## Last update Fri May 29 10:49:18 2009 Boutonnet Alexandre
## 
## ###################################
##

use Lib_TT;
use Lib_Log;
use Lib_Translation qw(Translate);
use Lib_Modules;
use HTML::Entities;

Lib_TT::new_tt("templates/global/", "templates/index/");
Lib_Translation::init("main.lang");


# Recuperation de l'utilisateur
my $user = Lib_CGI::session_get_param("user");

my $action = Lib_CGI::get_param('action');

if ($action eq "logout")
{
    Lib_CGI::close_session();
      Lib_TT::set("error_login", Translate("msg_session_closed"));
      require("pages/index/log.pl");
      exit(0);
}
elsif ($action eq "options")
{
      require("pages/index/options.pl");
      exit(0);
}

# Gestion de l'appelle aux modules
if (Lib_CGI::get_param('call') || Lib_CGI::get_url_param('call'))
{
    require("pages/call/main.pl");
    exit(0);
}

# Gestion de la presence du lien "preference"
if ($user eq "admin")
{
    Lib_TT::set("flag_admin", 1);
}

# Preparation de la hash pour l'affichage des liens sur
# les modules
my ($err_modules, $modules_hash) = Lib_Modules::list_modules();
Lib_CGI::send_critical_header($modules_hash) if ($err_modules);

my $user_right;
if ($user ne "admin")
{
    ($err_modules, $user_right) = Lib_Modules::get_user_right($user);
    Lib_CGI::send_critical_header($user_right) if ($err_modules);
}

my $tmp_modules_hash = {};
my $used_lang = Lib_Translation::get_current_lang();

foreach my $module (sort keys(%{$modules_hash}))
{
    next if ($user ne "admin" && !grep(/^$module$/, @$user_right));

    $tmp_modules_hash->{$module}->{'desc'} = $modules_hash->{$module}->{'desc'};
    $tmp_modules_hash->{$module}->{'desc'} = encode_entities($modules_hash->{$module}->{"desc_$used_lang"})
    if (exists($modules_hash->{$module}->{"desc_$used_lang"}));
    
    $tmp_modules_hash->{$module}->{'long_desc'} = $modules_hash->{$module}->{'long_desc'};
    $tmp_modules_hash->{$module}->{'long_desc'} = encode_entities($modules_hash->{$module}->{"long_desc_$used_lang"})
    if (exists($modules_hash->{$module}->{"long_desc_$used_lang"}));

    $tmp_modules_hash->{$module}->{'img'} = "static/img/img-missing_96x96.png";
    $tmp_modules_hash->{$module}->{'img'} = "modules/$module/".$modules_hash->{$module}->{"big_icon"}
    if (exists($modules_hash->{$module}->{"big_icon"}) && -r "modules/$module/".$modules_hash->{$module}->{"big_icon"});
}


Lib_TT::set("modules_hash", $tmp_modules_hash);

####### Go !!

Lib_TT::set("page_title", Translate("page_title"));
Lib_TT::set("link_options_page", Translate("link_option_page"));
Lib_TT::set("link_logout", Translate("link_logout"));

Lib_CGI::print_html_header();
Lib_TT::process("main.tt");

# Lib_CGI::debug();

1;
